function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Button from '../Button/Button';
import Input from './../Input/Input';
import Select from './../Select/Select';
import Textarea from './../Textarea/Textarea';
import rules from '../../rules';
var Form = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Form, _Component);
  function Form(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_assertThisInitialized(_this), "getErrors", function () {
      return Object.keys(_this.components).reduce(function (prev, name) {
        var component = _this.components[name];
        var validations = component.props.validations;
        var length = validations.length;
        for (var i = 0; i < length; i += 1) {
          if (!rules[validations[i]].rule(component.state.value, _this.components)) {
            /* eslint-disable */
            prev[name] = prev[name] || [];
            prev[name].push(validations[i]);
            /* eslint-enable */
          }
        }

        return prev;
      }, {});
    });
    _defineProperty(_assertThisInitialized(_this), "register", function (component) {
      _this.components[component.props.name] = component;
    });
    _defineProperty(_assertThisInitialized(_this), "unregister", function (component) {
      var errors = Object.assign({}, _this.state.errors);
      delete _this.components[component.props.name];
      delete errors[component.props.name];
      _this.setState({
        errors: errors
      });
    });
    _defineProperty(_assertThisInitialized(_this), "validateState", function () {
      var errors = _this.getErrors();
      _this.setState({
        errors: errors
      });
    });
    _defineProperty(_assertThisInitialized(_this), "validate", function (name) {
      _this.components[name].setState({
        isUsed: true,
        isChanged: true
      }, _this.validateState);
    });
    _defineProperty(_assertThisInitialized(_this), "showError", function (name, error) {
      _this.components[name].setState({
        isUsed: true,
        isChanged: true
      }, function () {
        var _extends2;
        _this.setState({
          errors: _extends({}, _this.state.errors, (_extends2 = {}, _extends2[name] = [error], _extends2))
        });
      });
    });
    _defineProperty(_assertThisInitialized(_this), "hideError", function (name) {
      var errors = Object.assign({}, _this.state.errors);
      delete errors[name];
      _this.setState({
        errors: errors
      });
    });
    _this.components = {};
    _this.state = {
      errors: {}
    };
    return _this;
  }
  var _proto = Form.prototype;
  _proto.getChildContext = function getChildContext() {
    return {
      register: this.register,
      unregister: this.unregister,
      validateState: this.validateState,
      components: this.components,
      errors: this.state.errors
    };
  };
  _proto.componentDidMount = function componentDidMount() {
    this.validateState();
  };
  _proto.validateAll = function validateAll() {
    var _this2 = this;
    Object.keys(this.components).forEach(function (name) {
      _this2.components[name].setState({
        isUsed: true,
        isChanged: true
      });
    });
    return this.getErrors();
  };
  _proto.render = function render() {
    return /*#__PURE__*/React.createElement("form", this.props, this.props.children);
  };
  return Form;
}(Component);
_defineProperty(Form, "childContextTypes", {
  register: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  validateState: PropTypes.func.isRequired,
  components: PropTypes.objectOf(PropTypes.oneOfType([PropTypes.instanceOf(Button), PropTypes.instanceOf(Input), PropTypes.instanceOf(Select), PropTypes.instanceOf(Textarea)])),
  errors: PropTypes.objectOf(PropTypes.array)
});
export { Form as default };
Form.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node
} : {};