var _excluded = ["validations", "errorClassName", "containerClassName", "errorContainerClassName", "className"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import rules from '../../rules';
import Base from '../Base/Base';
var Select = /*#__PURE__*/function (_Base) {
  _inheritsLoose(Select, _Base);
  function Select(props, context) {
    var _this;
    _this = _Base.call(this, props, context) || this;

    // TODO: Refactor conditions
    _this.state = {
      value: props.value,
      isChanged: !!props.value,
      isUsed: true,
      isChecked: true
    };
    context.register(_assertThisInitialized(_this));
    return _this;
  }
  var _proto = Select.prototype;
  _proto.render = function render() {
    var _cx, _cx2;
    var _this$props = this.props,
      validations = _this$props.validations,
      errorClassName = _this$props.errorClassName,
      containerClassName = _this$props.containerClassName,
      errorContainerClassName = _this$props.errorContainerClassName,
      className = _this$props.className,
      rest = _objectWithoutPropertiesLoose(_this$props, _excluded);
    // TODO: Refactor conditions
    var isInvalid = this.state.isUsed && this.state.isChanged && !!this.context.errors[this.props.name];
    var error = isInvalid && this.context.errors[this.props.name][0];
    var hint = null;
    if (isInvalid) {
      hint = typeof error === 'function' ? error(this.state.value, this.context.components) : rules[error].hint(this.state.value, this.context.components);
    }
    return /*#__PURE__*/React.createElement("div", {
      className: cx((_cx = {}, _cx[containerClassName] = !!containerClassName, _cx[errorContainerClassName] = !!error && errorContainerClassName, _cx))
    }, /*#__PURE__*/React.createElement("select", _extends({}, rest, {
      className: cx((_cx2 = {}, _cx2[className] = !!className, _cx2[errorClassName] = !!error && errorClassName, _cx2)),
      value: this.state.value,
      onChange: this.onChange,
      onBlur: this.onBlur
    }), this.props.children), hint);
  };
  return Select;
}(Base);
_defineProperty(Select, "propTypes", {
  validations: PropTypes.arrayOf(PropTypes.string).isRequired,
  errorClassName: PropTypes.string,
  containerClassName: PropTypes.string,
  errorContainerClassName: PropTypes.string
});
_defineProperty(Select, "contextTypes", {
  register: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  validateState: PropTypes.func.isRequired,
  components: PropTypes.objectOf(PropTypes.any),
  errors: PropTypes.objectOf(PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, PropTypes.node])))
});
export { Select as default };