"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _noop = _interopRequireDefault(require("../../utils/noop"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Base = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Base, _Component);
  function Base() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _defineProperty(_assertThisInitialized(_this), "onChange", function (event) {
      // TODO: Refactor conditions
      var isChecked = _this.state.isCheckbox ? !_this.state.isChecked : true;
      var checkboxValue = isChecked ? event.target.value : '';
      var value = _this.state.isCheckbox ? checkboxValue : event.target.value;
      event.persist();
      _this.setState({
        value: value,
        isChanged: true,
        isChecked: isChecked
      }, function () {
        _this.context.validateState(_this.props.name);
        (_this.props.onChange || _noop["default"])(event);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      event.persist();
      _this.setState({
        isUsed: true
      }, function () {
        _this.context.validateState(_this.props.name);
        (_this.props.onBlur || _noop["default"])(event);
      });
    });
    return _this;
  }
  var _proto = Base.prototype;
  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _this2 = this;
    if (nextProps.value !== this.props.value) {
      this.setState({
        value: nextProps.value,
        isChanged: true
      }, function () {
        _this2.context.validateState(_this2.props.name);
      });
    }
  };
  _proto.componentWillUnmount = function componentWillUnmount() {
    this.context.unregister(this);
  };
  return Base;
}(_react.Component);
_defineProperty(Base, "contextTypes", {
  register: _propTypes["default"].func.isRequired,
  unregister: _propTypes["default"].func.isRequired,
  validateState: _propTypes["default"].func.isRequired,
  components: _propTypes["default"].objectOf(_propTypes["default"].any),
  errors: _propTypes["default"].objectOf(_propTypes["default"].array)
});
Base.propTypes = process.env.NODE_ENV !== "production" ? {
  value: _propTypes["default"].string.isRequired,
  name: _propTypes["default"].string.isRequired,
  onChange: _propTypes["default"].func,
  onBlur: _propTypes["default"].func
} : {};
var _default = Base;
exports["default"] = _default;
module.exports = exports.default;