"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Button = _interopRequireDefault(require("../Button/Button"));
var _Input = _interopRequireDefault(require("./../Input/Input"));
var _Select = _interopRequireDefault(require("./../Select/Select"));
var _Textarea = _interopRequireDefault(require("./../Textarea/Textarea"));
var _rules = _interopRequireDefault(require("../../rules"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Form = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Form, _Component);
  function Form(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_assertThisInitialized(_this), "getErrors", function () {
      return Object.keys(_this.components).reduce(function (prev, name) {
        var component = _this.components[name];
        var validations = component.props.validations;
        var length = validations.length;
        for (var i = 0; i < length; i += 1) {
          if (!_rules["default"][validations[i]].rule(component.state.value, _this.components)) {
            /* eslint-disable */
            prev[name] = prev[name] || [];
            prev[name].push(validations[i]);
            /* eslint-enable */
          }
        }

        return prev;
      }, {});
    });
    _defineProperty(_assertThisInitialized(_this), "register", function (component) {
      _this.components[component.props.name] = component;
    });
    _defineProperty(_assertThisInitialized(_this), "unregister", function (component) {
      var errors = Object.assign({}, _this.state.errors);
      delete _this.components[component.props.name];
      delete errors[component.props.name];
      _this.setState({
        errors: errors
      });
    });
    _defineProperty(_assertThisInitialized(_this), "validateState", function () {
      var errors = _this.getErrors();
      _this.setState({
        errors: errors
      });
    });
    _defineProperty(_assertThisInitialized(_this), "validate", function (name) {
      _this.components[name].setState({
        isUsed: true,
        isChanged: true
      }, _this.validateState);
    });
    _defineProperty(_assertThisInitialized(_this), "showError", function (name, error) {
      _this.components[name].setState({
        isUsed: true,
        isChanged: true
      }, function () {
        var _extends2;
        _this.setState({
          errors: _extends({}, _this.state.errors, (_extends2 = {}, _extends2[name] = [error], _extends2))
        });
      });
    });
    _defineProperty(_assertThisInitialized(_this), "hideError", function (name) {
      var errors = Object.assign({}, _this.state.errors);
      delete errors[name];
      _this.setState({
        errors: errors
      });
    });
    _this.components = {};
    _this.state = {
      errors: {}
    };
    return _this;
  }
  var _proto = Form.prototype;
  _proto.getChildContext = function getChildContext() {
    return {
      register: this.register,
      unregister: this.unregister,
      validateState: this.validateState,
      components: this.components,
      errors: this.state.errors
    };
  };
  _proto.componentDidMount = function componentDidMount() {
    this.validateState();
  };
  _proto.validateAll = function validateAll() {
    var _this2 = this;
    Object.keys(this.components).forEach(function (name) {
      _this2.components[name].setState({
        isUsed: true,
        isChanged: true
      });
    });
    return this.getErrors();
  };
  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("form", this.props, this.props.children);
  };
  return Form;
}(_react.Component);
exports["default"] = Form;
_defineProperty(Form, "childContextTypes", {
  register: _propTypes["default"].func.isRequired,
  unregister: _propTypes["default"].func.isRequired,
  validateState: _propTypes["default"].func.isRequired,
  components: _propTypes["default"].objectOf(_propTypes["default"].oneOfType([_propTypes["default"].instanceOf(_Button["default"]), _propTypes["default"].instanceOf(_Input["default"]), _propTypes["default"].instanceOf(_Select["default"]), _propTypes["default"].instanceOf(_Textarea["default"])])),
  errors: _propTypes["default"].objectOf(_propTypes["default"].array)
});
Form.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node
} : {};
module.exports = exports.default;