"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rules = _interopRequireDefault(require("../../rules"));
var _Base2 = _interopRequireDefault(require("../Base/Base"));
var _excluded = ["validations", "errorClassName", "containerClassName", "errorContainerClassName", "className"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Textarea = /*#__PURE__*/function (_Base) {
  _inheritsLoose(Textarea, _Base);
  function Textarea(props, context) {
    var _this;
    _this = _Base.call(this, props, context) || this;
    _this.state = {
      value: props.value,
      isChanged: !!props.value,
      isUsed: false,
      isChecked: true
    };
    context.register(_assertThisInitialized(_this));
    return _this;
  }
  var _proto = Textarea.prototype;
  _proto.render = function render() {
    var _cx, _cx2;
    var _this$props = this.props,
      validations = _this$props.validations,
      errorClassName = _this$props.errorClassName,
      containerClassName = _this$props.containerClassName,
      errorContainerClassName = _this$props.errorContainerClassName,
      className = _this$props.className,
      rest = _objectWithoutPropertiesLoose(_this$props, _excluded);
    // TODO: Refactor conditions
    var isInvalid = this.state.isUsed && this.state.isChanged && !!this.context.errors[this.props.name];
    var error = isInvalid && this.context.errors[this.props.name][0];
    var hint = null;
    if (isInvalid) {
      hint = typeof error === 'function' ? error(this.state.value, this.context.components) : _rules["default"][error].hint(this.state.value, this.context.components);
    }
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])((_cx = {}, _cx[containerClassName] = !!containerClassName, _cx[errorContainerClassName] = !!error && errorContainerClassName, _cx))
    }, /*#__PURE__*/_react["default"].createElement("textarea", _extends({}, rest, {
      className: (0, _classnames["default"])((_cx2 = {}, _cx2[className] = !!className, _cx2[errorClassName] = !!error && errorClassName, _cx2)),
      onChange: this.onChange,
      onBlur: this.onBlur,
      value: this.state.value
    })), hint);
  };
  return Textarea;
}(_Base2["default"]);
exports["default"] = Textarea;
_defineProperty(Textarea, "propTypes", {
  validations: _propTypes["default"].arrayOf(_propTypes["default"].string).isRequired,
  errorClassName: _propTypes["default"].string,
  containerClassName: _propTypes["default"].string,
  errorContainerClassName: _propTypes["default"].string
});
_defineProperty(Textarea, "contextTypes", {
  register: _propTypes["default"].func.isRequired,
  unregister: _propTypes["default"].func.isRequired,
  validateState: _propTypes["default"].func.isRequired,
  components: _propTypes["default"].objectOf(_propTypes["default"].any),
  errors: _propTypes["default"].objectOf(_propTypes["default"].array)
});
module.exports = exports.default;